-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Menu - Scrolling
The DevExtreme JavaScript Menu component supports submenu item scrolling. If combined item height exceeds screen size or a pre-defined height limit, a scrollbar appears on-screen.
You can use one of the following event handlers to configure submenus as requirements dictate:
These handlers can access the root submenu element (submenuContainer) and data from root and submenu items (itemData).
In this demo, the onSubmenuShowing function limits submenu height to 200px.
Backend API
$(() => {
const SUBMENU_HEIGHT = 200;
let submenuMaxHeight = 0;
$('#menu').dxMenu({
dataSource: menuData,
hideSubmenuOnMouseLeave: false,
onSubmenuShowing: ({ submenuContainer }) => {
$(submenuContainer).css('maxHeight', submenuMaxHeight || '');
},
onItemClick(e) {
if (!e.itemData.items) {
DevExpress.ui.notify(`The "${e.itemData.text}" item was clicked`, 'success', 1500);
}
},
}).dxMenu('instance');
$('#limit-height').dxCheckBox({
value: false,
text: `Limit submenu height to ${SUBMENU_HEIGHT}px`,
onValueChanged(data) {
submenuMaxHeight = data.value ? SUBMENU_HEIGHT : 0;
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="content">
<div class="label">Catalog:</div>
<div id="menu"></div>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<div id="limit-height"></div>
</div>
</div>
</div>
</body>
</html>
.demo-container {
display: flex;
}
.label {
font-size: 22px;
padding-bottom: 24px;
}
.content {
flex-grow: 1;
width: 100%;
min-width: 500px;
overflow: clip;
}
.options {
display: flex;
flex-direction: column;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
const menuData = [
{
text: 'Electronics',
items: [
{
text: 'Computers',
items: [
{
text: 'Desktops',
},
{
text: 'Laptops',
},
{
text: 'Tablets',
},
{
text: 'Monitors',
},
{
text: 'Printers',
},
{
text: 'Scanners',
},
{
text: 'Servers',
},
{
text: 'Network Devices',
},
{
text: 'Warranties',
},
{
text: 'Projectors & Screens',
},
{
text: 'Computer Accessories',
},
],
},
{
text: 'Cell Phones',
items: [
{
text: 'Home & Office Phones',
},
{
text: 'Smart Phones & PDAs',
},
{
text: 'Senior Cell Phones',
},
{
text: 'Mobile Broadband Devices',
},
{
text: 'Cell Phone Accessories',
},
],
},
{
text: 'Camera & Photo',
items: [
{
text: 'Action Cameras',
},
{
text: 'Camcorders',
},
{
text: 'Digital Cameras',
},
{
text: 'Digital Picture Frames',
},
{
text: 'Film Cameras',
},
{
text: 'Professional Video Cameras',
},
{
text: 'Flashes',
},
{
text: 'Lenses',
},
{
text: 'Photo Printers',
},
{
text: 'Film & Slide Scanners',
},
{
text: 'Slide Projectors',
},
{
text: 'Slide Viewers',
},
{
text: 'Tripods & Monopods',
},
{
text: 'Underwater Video & Photography',
},
{
text: 'Camera Accessories',
},
],
},
{
text: 'Audio',
items: [
{
text: 'Boomboxes',
},
{
text: 'DVD & CD Player Bags',
},
{
text: 'Hi-Fi & Home Audio Accessories',
},
{
text: 'Media Streaming Devices',
},
{
text: 'MP3 & Digital Media Players',
},
{
text: 'MP3 Player Accessories',
},
{
text: 'Personal Cassette Players',
},
{
text: 'Personal CD Players',
},
{
text: 'Compact Stereos',
},
{
text: 'Speakers',
},
],
},
{
text: 'Home Appliances',
items: [
{
text: 'Air Conditioners',
},
{
text: 'Coffee Machines',
},
{
text: 'Fans',
},
{
text: 'Lamps',
},
{
text: 'Microwaves',
},
{
text: 'Refrigerators',
},
{
text: 'Washers & Dryers',
},
{
text: ' Water Heaters',
},
{
'text': 'Vacuum',
},
{
text: 'Steaming & Ironing',
},
],
},
],
},
{
text: 'Entertainment',
items: [
{
text: 'Films & Music',
items: [
{
text: 'TV Shows',
},
{
text: 'DVD',
},
{
text: 'Blu-ray',
},
{
text: 'CD',
},
{
text: 'SACD',
},
{
text: 'Vinyl',
},
{
text: 'Cassette',
},
{
text: 'Musical Instruments',
},
{
text: 'DJ Equipment',
},
],
},
{
text: 'Games & Toys',
items: [
{
text: 'PC Games',
},
{
text: 'Virtual Reality',
},
{
text: 'Boxed Games',
},
{
text: 'Download Games',
},
{
text: 'Handheld Game Systems',
},
{
text: 'Legacy Systems',
},
{
text: 'Cards',
},
],
},
],
},
{
text: 'Healthcare & Living',
items: [
{
text: 'Sports & Outdoors',
items: [
{
text: 'Camping',
},
{
text: 'Fitness',
},
{
text: 'Football',
},
{
text: 'Cycling',
},
{
text: 'Running',
},
{
text: 'Sport Electronics',
},
{
text: 'Sport Apparel',
},
{
text: 'Trainers & Tennis Shoes',
},
],
},
{
text: 'Beauty',
items: [
{
text: 'Bath & Shower',
},
{
text: 'Skin Care',
},
{
text: 'Hair Care',
},
{
text: 'Nail Care',
},
{
text: 'Make-up',
},
{
text: 'Fragrance',
},
{
text: 'Salon & SPA Equipment',
},
{
text: 'Tools & Accessories',
},
],
},
{
text: 'Fashion',
items: [
{
text: 'Clothing',
},
{
text: 'Jewellery',
},
{
text: 'Shoes',
},
{
text: 'Handbags & Shoulder Bags',
},
{
text: 'Watches',
},
{
text: 'Accessories',
},
],
},
],
},
];

Backend API
<div class="demo-container">
<div class="content">
<div class="label">Catalog:</div>
<dx-menu
#menu
[dataSource]="products"
(onItemClick)="itemClick($event)"
(onSubmenuShowing)="onSubmenuShowing($event)"
>
</dx-menu>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<dx-check-box
text="Limit submenu height to {{ SUBMENU_HEIGHT }}px"
[(value)]="limitSubmenuHeight"
></dx-check-box>
</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxCheckBoxModule } from 'devextreme-angular';
import { DxMenuModule, type DxMenuTypes } from 'devextreme-angular/ui/menu';
import notify from 'devextreme/ui/notify';
import { Service, type Product } from './app.service';
if (!document.location.host.includes('localhost')) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxMenuModule,
DxCheckBoxModule,
],
})
export class AppComponent {
products: Product[];
SUBMENU_HEIGHT = 200;
limitSubmenuHeight = false;
constructor(service: Service) {
this.products = service.getProducts();
}
itemClick(e: DxMenuTypes.ItemClickEvent<Product>) {
if (!e.itemData.items) {
notify(`The "${e.itemData.text}" item was clicked`, 'success', 1500);
}
}
onSubmenuShowing({ submenuContainer }: DxMenuTypes.SubmenuShowingEvent) {
submenuContainer.style.maxHeight = this.limitSubmenuHeight ? `${this.SUBMENU_HEIGHT}px` : '';
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .demo-container {
display: flex;
}
::ng-deep .label {
font-size: 22px;
padding-bottom: 24px;
}
::ng-deep .content {
flex-grow: 1;
width: 100%;
min-width: 500px;
overflow: clip;
}
::ng-deep .options {
display: flex;
flex-direction: column;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
::ng-deep .caption {
font-size: 18px;
font-weight: 500;
}
::ng-deep .option {
margin-top: 10px;
}
import { Injectable } from '@angular/core';
class ProductItem {
text: string;
}
export class Product {
text: string;
items: (Product | ProductItem)[];
}
const products: Product[] = [
{
text: 'Electronics',
items: [
{
text: 'Computers',
items: [
{
text: 'Desktops',
},
{
text: 'Laptops',
},
{
text: 'Tablets',
},
{
text: 'Monitors',
},
{
text: 'Printers',
},
{
text: 'Scanners',
},
{
text: 'Servers',
},
{
text: 'Network Devices',
},
{
text: 'Warranties',
},
{
text: 'Projectors & Screens',
},
{
text: 'Computer Accessories',
},
],
},
{
text: 'Cell Phones',
items: [
{
text: 'Home & Office Phones',
},
{
text: 'Smart Phones & PDAs',
},
{
text: 'Senior Cell Phones',
},
{
text: 'Mobile Broadband Devices',
},
{
text: 'Cell Phone Accessories',
},
],
},
{
text: 'Camera & Photo',
items: [
{
text: 'Action Cameras',
},
{
text: 'Camcorders',
},
{
text: 'Digital Cameras',
},
{
text: 'Digital Picture Frames',
},
{
text: 'Film Cameras',
},
{
text: 'Professional Video Cameras',
},
{
text: 'Flashes',
},
{
text: 'Lenses',
},
{
text: 'Photo Printers',
},
{
text: 'Film & Slide Scanners',
},
{
text: 'Slide Projectors',
},
{
text: 'Slide Viewers',
},
{
text: 'Tripods & Monopods',
},
{
text: 'Underwater Video & Photography',
},
{
text: 'Camera Accessories',
},
],
},
{
text: 'Audio',
items: [
{
text: 'Boomboxes',
},
{
text: 'DVD & CD Player Bags',
},
{
text: 'Hi-Fi & Home Audio Accessories',
},
{
text: 'Media Streaming Devices',
},
{
text: 'MP3 & Digital Media Players',
},
{
text: 'MP3 Player Accessories',
},
{
text: 'Personal Cassette Players',
},
{
text: 'Personal CD Players',
},
{
text: 'Compact Stereos',
},
{
text: 'Speakers',
},
],
},
{
text: 'Home Appliances',
items: [
{
text: 'Air Conditioners',
},
{
text: 'Coffee Machines',
},
{
text: 'Fans',
},
{
text: 'Lamps',
},
{
text: 'Microwaves',
},
{
text: 'Refrigerators',
},
{
text: 'Washers & Dryers',
},
{
text: ' Water Heaters',
},
{
'text': 'Vacuum',
},
{
text: 'Steaming & Ironing',
},
],
},
],
},
{
text: 'Entertainment',
items: [
{
text: 'Films & Music',
items: [
{
text: 'TV Shows',
},
{
text: 'DVD',
},
{
text: 'Blu-ray',
},
{
text: 'CD',
},
{
text: 'SACD',
},
{
text: 'Vinyl',
},
{
text: 'Cassette',
},
{
text: 'Musical Instruments',
},
{
text: 'DJ Equipment',
},
],
},
{
text: 'Games & Toys',
items: [
{
text: 'PC Games',
},
{
text: 'Virtual Reality',
},
{
text: 'Boxed Games',
},
{
text: 'Download Games',
},
{
text: 'Handheld Game Systems',
},
{
text: 'Legacy Systems',
},
{
text: 'Cards',
},
],
},
],
},
{
text: 'Healthcare & Living',
items: [
{
text: 'Sports & Outdoors',
items: [
{
text: 'Camping',
},
{
text: 'Fitness',
},
{
text: 'Football',
},
{
text: 'Cycling',
},
{
text: 'Running',
},
{
text: 'Sport Electronics',
},
{
text: 'Sport Apparel',
},
{
text: 'Trainers & Tennis Shoes',
},
],
},
{
text: 'Beauty',
items: [
{
text: 'Bath & Shower',
},
{
text: 'Skin Care',
},
{
text: 'Hair Care',
},
{
text: 'Nail Care',
},
{
text: 'Make-up',
},
{
text: 'Fragrance',
},
{
text: 'Salon & SPA Equipment',
},
{
text: 'Tools & Accessories',
},
],
},
{
text: 'Fashion',
items: [
{
text: 'Clothing',
},
{
text: 'Jewellery',
},
{
text: 'Shoes',
},
{
text: 'Handbags & Shoulder Bags',
},
{
text: 'Watches',
},
{
text: 'Accessories',
},
],
},
],
},
];
@Injectable()
export class Service {
getProducts(): Product[] {
return products;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<demo-app>Loading...</demo-app>
</body>
</html>

Backend API
<template>
<div class="demo-container">
<div class="content">
<div class="label">Catalog:</div>
<DxMenu
:data-source="products"
@item-click="itemClick"
@submenu-showing="onSubmenuShowing"
/>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<DxCheckBox
v-model:value="limitSubmenuHeight"
:text="`Limit submenu height to ${SUBMENU_HEIGHT}px`"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxMenu, { type DxMenuTypes } from 'devextreme-vue/menu';
import DxCheckBox from 'devextreme-vue/check-box';
import notify from 'devextreme/ui/notify';
import service from './data.ts';
import type { ProductType } from './types';
const SUBMENU_HEIGHT = 200;
const products = ref(service.getProducts());
const limitSubmenuHeight = ref(false);
function itemClick(e: DxMenuTypes.ItemClickEvent<ProductType>) {
if (!e.itemData?.items) {
notify(`The "${e.itemData?.text}" item was clicked`, 'success', 1500);
}
}
function onSubmenuShowing(e: DxMenuTypes.SubmenuShowingEvent<ProductType>) {
if (e.submenuContainer) {
e.submenuContainer.style.maxHeight = limitSubmenuHeight.value ? `${SUBMENU_HEIGHT}px` : '';
}
}
</script>
<style>
.demo-container {
display: flex;
}
.label {
font-size: 22px;
padding-bottom: 24px;
}
.content {
flex-grow: 1;
width: 100%;
min-width: 500px;
overflow: clip;
}
.options {
display: flex;
flex-direction: column;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import type { ProductType } from './types';
const products: ProductType[] = [
{
text: 'Electronics',
items: [
{
text: 'Computers',
items: [
{
text: 'Desktops',
},
{
text: 'Laptops',
},
{
text: 'Tablets',
},
{
text: 'Monitors',
},
{
text: 'Printers',
},
{
text: 'Scanners',
},
{
text: 'Servers',
},
{
text: 'Network Devices',
},
{
text: 'Warranties',
},
{
text: 'Projectors & Screens',
},
{
text: 'Computer Accessories',
},
],
},
{
text: 'Cell Phones',
items: [
{
text: 'Home & Office Phones',
},
{
text: 'Smart Phones & PDAs',
},
{
text: 'Senior Cell Phones',
},
{
text: 'Mobile Broadband Devices',
},
{
text: 'Cell Phone Accessories',
},
],
},
{
text: 'Camera & Photo',
items: [
{
text: 'Action Cameras',
},
{
text: 'Camcorders',
},
{
text: 'Digital Cameras',
},
{
text: 'Digital Picture Frames',
},
{
text: 'Film Cameras',
},
{
text: 'Professional Video Cameras',
},
{
text: 'Flashes',
},
{
text: 'Lenses',
},
{
text: 'Photo Printers',
},
{
text: 'Film & Slide Scanners',
},
{
text: 'Slide Projectors',
},
{
text: 'Slide Viewers',
},
{
text: 'Tripods & Monopods',
},
{
text: 'Underwater Video & Photography',
},
{
text: 'Camera Accessories',
},
],
},
{
text: 'Audio',
items: [
{
text: 'Boomboxes',
},
{
text: 'DVD & CD Player Bags',
},
{
text: 'Hi-Fi & Home Audio Accessories',
},
{
text: 'Media Streaming Devices',
},
{
text: 'MP3 & Digital Media Players',
},
{
text: 'MP3 Player Accessories',
},
{
text: 'Personal Cassette Players',
},
{
text: 'Personal CD Players',
},
{
text: 'Compact Stereos',
},
{
text: 'Speakers',
},
],
},
{
text: 'Home Appliances',
items: [
{
text: 'Air Conditioners',
},
{
text: 'Coffee Machines',
},
{
text: 'Fans',
},
{
text: 'Lamps',
},
{
text: 'Microwaves',
},
{
text: 'Refrigerators',
},
{
text: 'Washers & Dryers',
},
{
text: ' Water Heaters',
},
{
'text': 'Vacuum',
},
{
text: 'Steaming & Ironing',
},
],
},
],
},
{
text: 'Entertainment',
items: [
{
text: 'Films & Music',
items: [
{
text: 'TV Shows',
},
{
text: 'DVD',
},
{
text: 'Blu-ray',
},
{
text: 'CD',
},
{
text: 'SACD',
},
{
text: 'Vinyl',
},
{
text: 'Cassette',
},
{
text: 'Musical Instruments',
},
{
text: 'DJ Equipment',
},
],
},
{
text: 'Games & Toys',
items: [
{
text: 'PC Games',
},
{
text: 'Virtual Reality',
},
{
text: 'Boxed Games',
},
{
text: 'Download Games',
},
{
text: 'Handheld Game Systems',
},
{
text: 'Legacy Systems',
},
{
text: 'Cards',
},
],
},
],
},
{
text: 'Healthcare & Living',
items: [
{
text: 'Sports & Outdoors',
items: [
{
text: 'Camping',
},
{
text: 'Fitness',
},
{
text: 'Football',
},
{
text: 'Cycling',
},
{
text: 'Running',
},
{
text: 'Sport Electronics',
},
{
text: 'Sport Apparel',
},
{
text: 'Trainers & Tennis Shoes',
},
],
},
{
text: 'Beauty',
items: [
{
text: 'Bath & Shower',
},
{
text: 'Skin Care',
},
{
text: 'Hair Care',
},
{
text: 'Nail Care',
},
{
text: 'Make-up',
},
{
text: 'Fragrance',
},
{
text: 'Salon & SPA Equipment',
},
{
text: 'Tools & Accessories',
},
],
},
{
text: 'Fashion',
items: [
{
text: 'Clothing',
},
{
text: 'Jewellery',
},
{
text: 'Shoes',
},
{
text: 'Handbags & Shoulder Bags',
},
{
text: 'Watches',
},
{
text: 'Accessories',
},
],
},
],
},
];
export default {
getProducts() {
return products;
},
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
interface ProductItemType {
text: string;
}
export interface ProductType {
text: string;
items: (ProductType | ProductItemType)[];
}
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div id="app"></div>
</body>
</html>

Backend API
import React, { useCallback, useState } from 'react';
import Menu, { type MenuTypes } from 'devextreme-react/menu';
import CheckBox, { type CheckBoxTypes } from 'devextreme-react/check-box';
import notify from 'devextreme/ui/notify';
import { products } from './data.ts';
import type { Product } from './types';
const SUBMENU_HEIGHT = 200;
const App = () => {
const [limitSubmenuHeight, setLimitSubmenuHeight] = useState<boolean>(false);
const itemClick = useCallback((e: MenuTypes.ItemClickEvent<Product>): void => {
if (!e.itemData?.items) {
notify(`The "${e.itemData?.text}" item was clicked`, 'success', 1500);
}
}, []);
const limitSubmenuHeightOnMouseClick = useCallback((e: CheckBoxTypes.ValueChangedEvent): void => {
setLimitSubmenuHeight(e.value);
}, []);
const onSubmenuShowing = useCallback((e: MenuTypes.SubmenuShowingEvent<Product>): void => {
if (!e.submenuContainer) {
return;
}
e.submenuContainer.style.maxHeight = limitSubmenuHeight ? `${SUBMENU_HEIGHT}px` : '';
}, [limitSubmenuHeight]);
return (
<div className="demo-container">
<div className="content">
<div className="label">Catalog:</div>
<Menu
dataSource={products}
onItemClick={itemClick}
onSubmenuShowing={onSubmenuShowing}
/>
</div>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<CheckBox
text={`Limit submenu height to ${SUBMENU_HEIGHT}px`}
value={limitSubmenuHeight}
onValueChanged={limitSubmenuHeightOnMouseClick}
/>
</div>
</div>
</div>
);
};
export default App;
import React, { useCallback, useState } from 'react';
import Menu from 'devextreme-react/menu';
import CheckBox from 'devextreme-react/check-box';
import notify from 'devextreme/ui/notify';
import { products } from './data.js';
const SUBMENU_HEIGHT = 200;
const App = () => {
const [limitSubmenuHeight, setLimitSubmenuHeight] = useState(false);
const itemClick = useCallback((e) => {
if (!e.itemData?.items) {
notify(`The "${e.itemData?.text}" item was clicked`, 'success', 1500);
}
}, []);
const limitSubmenuHeightOnMouseClick = useCallback((e) => {
setLimitSubmenuHeight(e.value);
}, []);
const onSubmenuShowing = useCallback(
(e) => {
if (!e.submenuContainer) {
return;
}
e.submenuContainer.style.maxHeight = limitSubmenuHeight ? `${SUBMENU_HEIGHT}px` : '';
},
[limitSubmenuHeight],
);
return (
<div className="demo-container">
<div className="content">
<div className="label">Catalog:</div>
<Menu
dataSource={products}
onItemClick={itemClick}
onSubmenuShowing={onSubmenuShowing}
/>
</div>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<CheckBox
text={`Limit submenu height to ${SUBMENU_HEIGHT}px`}
value={limitSubmenuHeight}
onValueChanged={limitSubmenuHeightOnMouseClick}
/>
</div>
</div>
</div>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { Product } from './types';
export const products: Product[] = [
{
text: 'Electronics',
items: [
{
text: 'Computers',
items: [
{
text: 'Desktops',
},
{
text: 'Laptops',
},
{
text: 'Tablets',
},
{
text: 'Monitors',
},
{
text: 'Printers',
},
{
text: 'Scanners',
},
{
text: 'Servers',
},
{
text: 'Network Devices',
},
{
text: 'Warranties',
},
{
text: 'Projectors & Screens',
},
{
text: 'Computer Accessories',
},
],
},
{
text: 'Cell Phones',
items: [
{
text: 'Home & Office Phones',
},
{
text: 'Smart Phones & PDAs',
},
{
text: 'Senior Cell Phones',
},
{
text: 'Mobile Broadband Devices',
},
{
text: 'Cell Phone Accessories',
},
],
},
{
text: 'Camera & Photo',
items: [
{
text: 'Action Cameras',
},
{
text: 'Camcorders',
},
{
text: 'Digital Cameras',
},
{
text: 'Digital Picture Frames',
},
{
text: 'Film Cameras',
},
{
text: 'Professional Video Cameras',
},
{
text: 'Flashes',
},
{
text: 'Lenses',
},
{
text: 'Photo Printers',
},
{
text: 'Film & Slide Scanners',
},
{
text: 'Slide Projectors',
},
{
text: 'Slide Viewers',
},
{
text: 'Tripods & Monopods',
},
{
text: 'Underwater Video & Photography',
},
{
text: 'Camera Accessories',
},
],
},
{
text: 'Audio',
items: [
{
text: 'Boomboxes',
},
{
text: 'DVD & CD Player Bags',
},
{
text: 'Hi-Fi & Home Audio Accessories',
},
{
text: 'Media Streaming Devices',
},
{
text: 'MP3 & Digital Media Players',
},
{
text: 'MP3 Player Accessories',
},
{
text: 'Personal Cassette Players',
},
{
text: 'Personal CD Players',
},
{
text: 'Compact Stereos',
},
{
text: 'Speakers',
},
],
},
{
text: 'Home Appliances',
items: [
{
text: 'Air Conditioners',
},
{
text: 'Coffee Machines',
},
{
text: 'Fans',
},
{
text: 'Lamps',
},
{
text: 'Microwaves',
},
{
text: 'Refrigerators',
},
{
text: 'Washers & Dryers',
},
{
text: ' Water Heaters',
},
{
'text': 'Vacuum',
},
{
text: 'Steaming & Ironing',
},
],
},
],
},
{
text: 'Entertainment',
items: [
{
text: 'Films & Music',
items: [
{
text: 'TV Shows',
},
{
text: 'DVD',
},
{
text: 'Blu-ray',
},
{
text: 'CD',
},
{
text: 'SACD',
},
{
text: 'Vinyl',
},
{
text: 'Cassette',
},
{
text: 'Musical Instruments',
},
{
text: 'DJ Equipment',
},
],
},
{
text: 'Games & Toys',
items: [
{
text: 'PC Games',
},
{
text: 'Virtual Reality',
},
{
text: 'Boxed Games',
},
{
text: 'Download Games',
},
{
text: 'Handheld Game Systems',
},
{
text: 'Legacy Systems',
},
{
text: 'Cards',
},
],
},
],
},
{
text: 'Healthcare & Living',
items: [
{
text: 'Sports & Outdoors',
items: [
{
text: 'Camping',
},
{
text: 'Fitness',
},
{
text: 'Football',
},
{
text: 'Cycling',
},
{
text: 'Running',
},
{
text: 'Sport Electronics',
},
{
text: 'Sport Apparel',
},
{
text: 'Trainers & Tennis Shoes',
},
],
},
{
text: 'Beauty',
items: [
{
text: 'Bath & Shower',
},
{
text: 'Skin Care',
},
{
text: 'Hair Care',
},
{
text: 'Nail Care',
},
{
text: 'Make-up',
},
{
text: 'Fragrance',
},
{
text: 'Salon & SPA Equipment',
},
{
text: 'Tools & Accessories',
},
],
},
{
text: 'Fashion',
items: [
{
text: 'Clothing',
},
{
text: 'Jewellery',
},
{
text: 'Shoes',
},
{
text: 'Handbags & Shoulder Bags',
},
{
text: 'Watches',
},
{
text: 'Accessories',
},
],
},
],
},
];
interface ProductItem {
text: string;
}
export interface Product {
text: string;
items: (Product | ProductItem)[];
}
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const products = [
{
text: 'Electronics',
items: [
{
text: 'Computers',
items: [
{
text: 'Desktops',
},
{
text: 'Laptops',
},
{
text: 'Tablets',
},
{
text: 'Monitors',
},
{
text: 'Printers',
},
{
text: 'Scanners',
},
{
text: 'Servers',
},
{
text: 'Network Devices',
},
{
text: 'Warranties',
},
{
text: 'Projectors & Screens',
},
{
text: 'Computer Accessories',
},
],
},
{
text: 'Cell Phones',
items: [
{
text: 'Home & Office Phones',
},
{
text: 'Smart Phones & PDAs',
},
{
text: 'Senior Cell Phones',
},
{
text: 'Mobile Broadband Devices',
},
{
text: 'Cell Phone Accessories',
},
],
},
{
text: 'Camera & Photo',
items: [
{
text: 'Action Cameras',
},
{
text: 'Camcorders',
},
{
text: 'Digital Cameras',
},
{
text: 'Digital Picture Frames',
},
{
text: 'Film Cameras',
},
{
text: 'Professional Video Cameras',
},
{
text: 'Flashes',
},
{
text: 'Lenses',
},
{
text: 'Photo Printers',
},
{
text: 'Film & Slide Scanners',
},
{
text: 'Slide Projectors',
},
{
text: 'Slide Viewers',
},
{
text: 'Tripods & Monopods',
},
{
text: 'Underwater Video & Photography',
},
{
text: 'Camera Accessories',
},
],
},
{
text: 'Audio',
items: [
{
text: 'Boomboxes',
},
{
text: 'DVD & CD Player Bags',
},
{
text: 'Hi-Fi & Home Audio Accessories',
},
{
text: 'Media Streaming Devices',
},
{
text: 'MP3 & Digital Media Players',
},
{
text: 'MP3 Player Accessories',
},
{
text: 'Personal Cassette Players',
},
{
text: 'Personal CD Players',
},
{
text: 'Compact Stereos',
},
{
text: 'Speakers',
},
],
},
{
text: 'Home Appliances',
items: [
{
text: 'Air Conditioners',
},
{
text: 'Coffee Machines',
},
{
text: 'Fans',
},
{
text: 'Lamps',
},
{
text: 'Microwaves',
},
{
text: 'Refrigerators',
},
{
text: 'Washers & Dryers',
},
{
text: ' Water Heaters',
},
{
text: 'Vacuum',
},
{
text: 'Steaming & Ironing',
},
],
},
],
},
{
text: 'Entertainment',
items: [
{
text: 'Films & Music',
items: [
{
text: 'TV Shows',
},
{
text: 'DVD',
},
{
text: 'Blu-ray',
},
{
text: 'CD',
},
{
text: 'SACD',
},
{
text: 'Vinyl',
},
{
text: 'Cassette',
},
{
text: 'Musical Instruments',
},
{
text: 'DJ Equipment',
},
],
},
{
text: 'Games & Toys',
items: [
{
text: 'PC Games',
},
{
text: 'Virtual Reality',
},
{
text: 'Boxed Games',
},
{
text: 'Download Games',
},
{
text: 'Handheld Game Systems',
},
{
text: 'Legacy Systems',
},
{
text: 'Cards',
},
],
},
],
},
{
text: 'Healthcare & Living',
items: [
{
text: 'Sports & Outdoors',
items: [
{
text: 'Camping',
},
{
text: 'Fitness',
},
{
text: 'Football',
},
{
text: 'Cycling',
},
{
text: 'Running',
},
{
text: 'Sport Electronics',
},
{
text: 'Sport Apparel',
},
{
text: 'Trainers & Tennis Shoes',
},
],
},
{
text: 'Beauty',
items: [
{
text: 'Bath & Shower',
},
{
text: 'Skin Care',
},
{
text: 'Hair Care',
},
{
text: 'Nail Care',
},
{
text: 'Make-up',
},
{
text: 'Fragrance',
},
{
text: 'Salon & SPA Equipment',
},
{
text: 'Tools & Accessories',
},
],
},
{
text: 'Fashion',
items: [
{
text: 'Clothing',
},
{
text: 'Jewellery',
},
{
text: 'Shoes',
},
{
text: 'Handbags & Shoulder Bags',
},
{
text: 'Watches',
},
{
text: 'Accessories',
},
],
},
],
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div id="app"></div>
</body>
</html>
.demo-container {
display: flex;
}
.label {
font-size: 22px;
padding-bottom: 24px;
}
.content {
flex-grow: 1;
width: 100%;
min-width: 500px;
overflow: clip;
}
.options {
display: flex;
flex-direction: column;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}